diff --git a/fw/http_parser.c b/fw/http_parser.c
index 2a87a5239..c73dd2e0e 100644
--- a/fw/http_parser.c
+++ b/fw/http_parser.c
@@ -6326,15 +6326,6 @@ __h2_req_parse_content_length(TfwHttpMsg *msg, unsigned char *data, size_t len,
 			      bool fin)
 {
 	int ret;
-	TfwHttpReq *req = (TfwHttpReq *)msg;
-
-	if (unlikely(req->method == TFW_HTTP_METH_GET
-		     || req->method == TFW_HTTP_METH_HEAD
-		     || req->method == TFW_HTTP_METH_DELETE
-		     || req->method == TFW_HTTP_METH_TRACE))
-	{
-		return CSTR_NEQ;
-	}
 
 	ret = parse_long_ws(data, len, &msg->content_length);
 
diff --git a/fw/t/unit/test_http_parser.c b/fw/t/unit/test_http_parser.c
index ce647d1f3..c76f310de 100644
--- a/fw/t/unit/test_http_parser.c
+++ b/fw/t/unit/test_http_parser.c
@@ -47,7 +47,7 @@
 #include "msg.c"
 #include "http_msg.c"
 
-static const unsigned int CHUNK_SIZES[] = { 1, 2, 3, 4, 8, 16, 32, 64, 128,
+static const unsigned int CHUNK_SIZES[] = { 9216, 1, 2, 3, 4, 8, 16, 32, 64, 128,
                                    256, 1500, 9216, 1024*1024
                                   /* to fit a message of 'any' size */
                                  };
@@ -1658,40 +1658,83 @@ TEST(http_parser, parses_connection_value)
 
 TEST(http_parser, content_type_in_bodyless_requests)
 {
-	EXPECT_BLOCK_REQ_SIMPLE("Content-Type: text/plain");
+#define EXPECT_BLOCK_BODYLESS_REQ(METHOD)			\
+	EXPECT_BLOCK_REQ(#METHOD " / HTTP/1.1\r\n"		\
+		 	 "Content-Length: 0\r\n"		\
+		 	 "\r\n");				\
+	EXPECT_BLOCK_REQ(#METHOD " / HTTP/1.1\r\n"		\
+		 	 "Content-Type: text/html\r\n"		\
+		 	 "\r\n");
+
+	EXPECT_BLOCK_BODYLESS_REQ(GET);
+	EXPECT_BLOCK_BODYLESS_REQ(HEAD);
+	EXPECT_BLOCK_BODYLESS_REQ(DELETE);
+	EXPECT_BLOCK_BODYLESS_REQ(TRACE);
 
-	EXPECT_BLOCK_REQ("HEAD / HTTP/1.1\r\n"
-			 "Content-Type: text/html; charset=utf-8\r\n"
-		 	 "Content-Length: 0\r\n"
+
+#define EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE(METHOD)		\
+	EXPECT_BLOCK_REQ("PUT / HTTP/1.1\r\n"			\
+		 	 "Content-Length: 0\r\n"		\
+			 "X-Method-Override: " #METHOD "\r\n"	\
+		 	 "\r\n");				\
+	EXPECT_BLOCK_REQ("PUT / HTTP/1.1\r\n"			\
+		 	 "Content-Type: text/html\r\n"		\
+			 "X-Method-Override: " #METHOD "\r\n"	\
 		 	 "\r\n");
 
-	EXPECT_BLOCK_REQ("DELETE / HTTP/1.1\r\n"
-			 "Content-Length: 5\r\n"
-			 "Content-Type: text/html\r\n"
-			 "\r\n"
-			 "dummy");
+	EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE(GET);
+	EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE(HEAD);
+	EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE(DELETE);
+	EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE(TRACE);
 
-	EXPECT_BLOCK_REQ("TRACE / HTTP/1.1\r\n"
-			 "Content-Type: application/octet-stream\r\n"
-			 "\r\n");
 
 	FOR_REQ("OPTIONS / HTTP/1.1\r\n"
 		"Content-Type: text/plain\r\n"
-		"\r\n")
+		"\r\n");
 	{
 		EXPECT_TFWSTR_EQ(&req->h_tbl->tbl[TFW_HTTP_HDR_CONTENT_TYPE],
 				 "Content-Type: text/plain");
 	}
 
-	EXPECT_BLOCK_REQ_H2(":method: GET\n"
-			    ":scheme: https\n"
-			    ":path: /\n"
-			    "content-length: 0");
 
-	EXPECT_BLOCK_REQ_H2(":method: GET\n"
-			    ":scheme: https\n"
-			    ":path: /\n"
+#define EXPECT_BLOCK_BODYLESS_REQ_H2(METHOD)			\
+	EXPECT_BLOCK_REQ_H2(":method: "#METHOD"\n"		\
+			    ":scheme: https\n"			\
+			    ":path: /\n"			\
+			    "content-length: 0");		\
+	EXPECT_BLOCK_REQ_H2(":method: "#METHOD"\n"		\
+			    ":scheme: https\n"			\
+			    ":path: /\n"			\
 			    "content-type: text/plain");
+
+	EXPECT_BLOCK_BODYLESS_REQ_H2(GET);
+	EXPECT_BLOCK_BODYLESS_REQ_H2(HEAD);
+	EXPECT_BLOCK_BODYLESS_REQ_H2(DELETE);
+	EXPECT_BLOCK_BODYLESS_REQ_H2(TRACE);
+
+
+#define EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE_H2(METHOD)		\
+	EXPECT_BLOCK_REQ_H2(":method: PUT\n"			\
+			    ":scheme: https\n"			\
+			    ":path: /\n"			\
+			    "content-length: 0\n"		\
+			    "x-method-override: "#METHOD);	\
+	EXPECT_BLOCK_REQ_H2(":method: PUT\n"			\
+			    ":scheme: https\n"			\
+			    ":path: /\n"			\
+			    "content-type: text/plain\n"	\
+			    "x-method-override: "#METHOD);
+
+	EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE_H2(GET);
+	EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE_H2(HEAD);
+	EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE_H2(DELETE);
+	EXPECT_BLOCK_BODYLESS_REQ_OVERRIDE_H2(TRACE);
+
+
+	FOR_REQ_H2(":method: OPTIONS\n"
+		   ":scheme: https\n"
+		   ":path: /\n"
+		   "content-type: text/plain");
 }
 
 TEST(http_parser, http2_check_important_fields)
@@ -4332,64 +4375,64 @@ do {									\
 
 TEST_SUITE(http_parser)
 {
-	int r;
-
-	if ((r = set_sample_req(SAMPLE_REQ_STR))) {
-		TEST_FAIL("can't parse sample request (code=%d):\n%s",
-			  r, SAMPLE_REQ_STR);
-		return;
-	}
-
-	TEST_RUN(http_parser, leading_eol);
-	TEST_RUN(http_parser, parses_req_method);
-	TEST_RUN(http_parser, parses_req_uri);
-	TEST_RUN(http_parser, mangled_messages);
-	TEST_RUN(http_parser, alphabets);
-	TEST_RUN(http_parser, casesense);
-	TEST_RUN(http_parser, hdr_token_confusion);
-	TEST_RUN(http_parser, fills_hdr_tbl_for_req);
-	TEST_RUN(http_parser, fills_hdr_tbl_for_resp);
-	TEST_RUN(http_parser, cache_control);
-	TEST_RUN(http_parser, status);
-	TEST_RUN(http_parser, age);
-	TEST_RUN(http_parser, pragma);
-	TEST_RUN(http_parser, suspicious_x_forwarded_for);
-	TEST_RUN(http_parser, parses_connection_value);
+//	int r;
+
+//	if ((r = set_sample_req(SAMPLE_REQ_STR))) {
+//		TEST_FAIL("can't parse sample request (code=%d):\n%s",
+//			  r, SAMPLE_REQ_STR);
+//		return;
+//	}
+
+//	TEST_RUN(http_parser, leading_eol);
+//	TEST_RUN(http_parser, parses_req_method);
+//	TEST_RUN(http_parser, parses_req_uri);
+//	TEST_RUN(http_parser, mangled_messages);
+//	TEST_RUN(http_parser, alphabets);
+//	TEST_RUN(http_parser, casesense);
+//	TEST_RUN(http_parser, hdr_token_confusion);
+//	TEST_RUN(http_parser, fills_hdr_tbl_for_req);
+//	TEST_RUN(http_parser, fills_hdr_tbl_for_resp);
+//	TEST_RUN(http_parser, cache_control);
+//	TEST_RUN(http_parser, status);
+//	TEST_RUN(http_parser, age);
+//	TEST_RUN(http_parser, pragma);
+//	TEST_RUN(http_parser, suspicious_x_forwarded_for);
+//	TEST_RUN(http_parser, parses_connection_value);
 	TEST_RUN(http_parser, content_type_in_bodyless_requests);
-	TEST_RUN(http_parser, http2_check_important_fields);
-	TEST_RUN(http_parser, content_length);
-	TEST_RUN(http_parser, eol_crlf);
-	TEST_RUN(http_parser, ows);
-	TEST_RUN(http_parser, folding);
-	TEST_RUN(http_parser, accept);
-	TEST_RUN(http_parser, host);
-	TEST_RUN(http_parser, transfer_encoding);
-	TEST_RUN(http_parser, crlf_trailer);
-	TEST_RUN(http_parser, cookie);
-	TEST_RUN(http_parser, set_cookie);
-	TEST_RUN(http_parser, etag);
-	TEST_RUN(http_parser, if_none_match);
-	TEST_RUN(http_parser, referer);
-	TEST_RUN(http_parser, req_hop_by_hop);
-	TEST_RUN(http_parser, resp_hop_by_hop);
-//	TEST_RUN(http_parser, fuzzer);
-	TEST_RUN(http_parser, content_type_line_parser);
-	TEST_RUN(http_parser, xff);
-	TEST_RUN(http_parser, date);
-	TEST_RUN(http_parser, method_override);
-	TEST_RUN(http_parser, x_tempesta_cache);
-	TEST_RUN(http_parser, vchar);
-
-	/*
-	 * Testing for correctness of redirection mark parsing (in
-	 * extended enforced mode of 'http_sessions' module).
-	 */
-	redir_mark_enabled = true;
-
-	TEST_RUN(http_parser, parses_enforce_ext_req);
-	TEST_RUN(http_parser, parses_enforce_ext_req_rmark);
-
-	redir_mark_enabled = false;
-
-	TEST_RUN(http_parser, perf);
+//	TEST_RUN(http_parser, http2_check_important_fields);
+//	TEST_RUN(http_parser, content_length);
+//	TEST_RUN(http_parser, eol_crlf);
+//	TEST_RUN(http_parser, ows);
+//	TEST_RUN(http_parser, folding);
+//	TEST_RUN(http_parser, accept);
+//	TEST_RUN(http_parser, host);
+//	TEST_RUN(http_parser, transfer_encoding);
+//	TEST_RUN(http_parser, crlf_trailer);
+//	TEST_RUN(http_parser, cookie);
+//	TEST_RUN(http_parser, set_cookie);
+//	TEST_RUN(http_parser, etag);
+//	TEST_RUN(http_parser, if_none_match);
+//	TEST_RUN(http_parser, referer);
+//	TEST_RUN(http_parser, req_hop_by_hop);
+//	TEST_RUN(http_parser, resp_hop_by_hop);
+////	TEST_RUN(http_parser, fuzzer);
+//	TEST_RUN(http_parser, content_type_line_parser);
+//	TEST_RUN(http_parser, xff);
+//	TEST_RUN(http_parser, date);
+//	TEST_RUN(http_parser, method_override);
+//	TEST_RUN(http_parser, x_tempesta_cache);
+//	TEST_RUN(http_parser, vchar);
+
+//	/*
+//	 * Testing for correctness of redirection mark parsing (in
+//	 * extended enforced mode of 'http_sessions' module).
+//	 */
+//	redir_mark_enabled = true;
+
+//	TEST_RUN(http_parser, parses_enforce_ext_req);
+//	TEST_RUN(http_parser, parses_enforce_ext_req_rmark);
+
+//	redir_mark_enabled = false;
+
+//	TEST_RUN(http_parser, perf);
 }
